import { PropType } from 'vue';
import { IOrganizationTreeItem } from '../../interface';
import { ICanvasState, IConnectorState, ICoordinates, IDraggedItem, IMouseState, IParentPointerState, IParentState, IPointState, IPointTarget } from './interface';
declare const _default: import("vue").DefineComponent<{
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<IOrganizationTreeItem[]>;
    };
}, unknown, {
    canvasState: ICanvasState;
    canvasStyle: Record<string, any>;
    connectorState: IConnectorState;
    draggedItem: IDraggedItem | null;
    exportAreaStyle: Record<string, any>;
    isExporting: boolean;
    localList: IOrganizationTreeItem[];
    mouseState: IMouseState;
    parentPointerState: IParentPointerState;
    parentState: IParentState;
    pointState: IPointState;
    selectedConnection: string | null;
}, {}, {
    doExport(): Promise<string | null>;
    doParentZoom(inc: number): void;
    doParentZoomRefresh(): void;
    doSetTempConnectionPath(): void;
    doUpdateConnections(itemTrigger: number, updatedList: IOrganizationTreeItem[]): void;
    getCanvasRect(): any;
    getCoordinatesEnd(ev: MouseEvent | TouchEvent): {
        x: number;
        y: number;
    };
    getCoordinatesMove(ev: MouseEvent | TouchEvent): {
        x: number;
        y: number;
    };
    handleChangeItemPoint(item: IOrganizationTreeItem, index: number): void;
    handleConnectionDragged(io: string, fromRect: DOMRect): void;
    handleItemChangePosition(coordinates: ICoordinates): void;
    handleItemDragged(item: IDraggedItem): void;
    handleParentClick(ev: MouseEvent | TouchEvent): void;
    handleParentDragEnd(ev: MouseEvent | TouchEvent): void;
    handleParentKeydown(ev: KeyboardEvent): void;
    handleParentPointerDown(ev: PointerEvent): void;
    handleParentPointerMove(ev: PointerEvent): void;
    handleParentPointerUp(ev: PointerEvent): void;
    handleParentPosition(ev: MouseEvent | TouchEvent): void;
    handleParentZoom(ev: WheelEvent): void;
    handlePointDragged(target: IPointTarget, fromRect: DOMRect): void;
    handleSelectConnection(key: string): void;
    isConnectionExist(fromId: string, toId: string): boolean;
    isItemDragged(key: string): boolean;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    change: (_list: IOrganizationTreeItem[]) => boolean;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    isEditable: {
        required: false;
        type: BooleanConstructor;
    };
    list: {
        required: true;
        type: PropType<IOrganizationTreeItem[]>;
    };
}>> & {
    onChange?: ((_list: IOrganizationTreeItem[]) => any) | undefined;
}, {
    isEditable: boolean;
}, {}>;
export default _default;
